searchData={"content_type":"text/markdown","items":[{"doc":"It's a map format verifier, verify if keys/values exist in a given map, short and quick, you can specify more than one\nformat and verify list of values.\n\nJust use the function [`MapSchemaValidator.validate/2`](https://hexdocs.pm) or [`MapSchemaValidator.validate!/2`](https://hexdocs.pm)","ref":"MapSchemaValidator.html","title":"MapSchemaValidator","type":"module"},{"doc":"By param schema validates the param data and compares the format and values to ensure follows a specific format.","ref":"MapSchemaValidator.html#validate/2","title":"MapSchemaValidator.validate/2","type":"function"},{"doc":"iex> MapSchemaValidator.validate(%{key: :string}, %{key: \"value\"})\n    {:ok, nil}\n\n    iex> MapSchemaValidator.validate(%{key: [:string, :number]}, %{key: 1})\n    {:ok, nil}\n\n    iex> MapSchemaValidator.validate(%{key: [%{inner_key: :string}]}, %{key: [%{inner_key: \"value_1\"}, %{inner_key: \"value_2\"}]})\n    {:ok, nil}\n\n    iex> MapSchemaValidator.validate(%{key: [%{inner_key: :string}]}, %{key: [%{inner_key: 1}, %{inner_key: \"value_2\"}]})\n    {:error, %MapSchemaValidator.InvalidMapError{message: \"error at: key -> inner_key\"}}","ref":"MapSchemaValidator.html#validate/2-examples","title":"Examples - MapSchemaValidator.validate/2","type":"function"},{"doc":"Same as MapSchemaValidator.validate/2 but raises in fail.","ref":"MapSchemaValidator.html#validate!/2","title":"MapSchemaValidator.validate!/2","type":"function"},{"doc":"iex> MapSchemaValidator.validate!(%{key: :string}, %{key: \"value\"})\n    :ok\n\n    iex> MapSchemaValidator.validate!(%{key: [:string, :number]}, %{key: 1})\n    :ok\n\n    iex> MapSchemaValidator.validate!(%{key: [%{inner_key: :string}]}, %{key: [%{inner_key: \"value_1\"}, %{inner_key: \"value_2\"}]})\n    :ok\n\n    iex> MapSchemaValidator.validate!(%{key: [%{inner_key: :string}]}, %{key: [%{inner_key: 1}, %{inner_key: \"value_2\"}]})\n    ** (UndefinedFunctionError) function JsonValidator.validate/2 is undefined (module JsonValidator is not available)\n    JsonValidator.validate(%{schemas: [%{name: :string, fields: %{string: :string}, hooks?: [%{events: [:string, :integer], headers: %{string: :string}, method: :string, url: :string}]}]}, %{\"schemas\" => [%{\"fields\" => %{\"age\" => \"number\", \"birth\" => \"datetime\", \"male\" => \"boolean\", \"name\" => \"string\"}, \"hooks\" => [%{\"events\" => [\"create\", false], \"headers\" => %{\"key\" => \"value\"}, \"method\" => \"post\", \"url\" => \"https://someurl.test/webhook\"}], \"name\" => \"users\"}, %{\"fields\" => %{\"expiration\" => \"datetime\", \"name\" => \"string\"}, \"name\" => \"products\"}]})\n    /data/default_book.livemd#cell:hu7mznvjuk3vuqwpft3emi562ezmozpx:48: (file)","ref":"MapSchemaValidator.html#validate!/2-examples","title":"Examples - MapSchemaValidator.validate!/2","type":"function"},{"doc":"Documentation for `MapSchemaValidator`.","ref":"MapSchemaValidator.MapUtils.html","title":"MapSchemaValidator.MapUtils","type":"module"},{"doc":"Transforms maps with key-strings to maps with atom-strings.","ref":"MapSchemaValidator.MapUtils.html#map_to_atom_keys/1","title":"MapSchemaValidator.MapUtils.map_to_atom_keys/1","type":"function"},{"doc":"iex> MapSchemaValidator.MapUtils.map_to_atom_keys(%{\"key\" => \"value\"})\n    %{key: \"value\"}","ref":"MapSchemaValidator.MapUtils.html#map_to_atom_keys/1-examples","title":"Examples - MapSchemaValidator.MapUtils.map_to_atom_keys/1","type":"function"},{"doc":"","ref":"MapSchemaValidator.InvalidMapError.html","title":"MapSchemaValidator.InvalidMapError","type":"exception"},{"doc":"# MapSchemaValidator\n\nIt's a map format verifier, verify if keys/values exist in a given map, short and quick, you can specify more than one \nformat and verify list of values.\n\nThe motivation of create this library was verify that a json file content has a specific format and fail in case that \nnot matches raises an error with the route to the invalid field\n\n[Docs here!](https://hexdocs.pm/map_schema_validator)","ref":"readme.html","title":"MapSchemaValidator","type":"extras"},{"doc":"If [available in Hex](https://hex.pm/packages/map_schema_validator/0.1.1), the package can be installed\nby adding `map_schema_validator` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:map_schema_validator, \"~> 0.1.1\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - MapSchemaValidator","type":"extras"},{"doc":"Just use the function [`MapSchemaValidator.validate/2`](https://hexdocs.pm/map_schema_validator/0.1.1/MapSchemaValidator.html#validate/2) \nor [`MapSchemaValidator.validate!/2`](https://hexdocs.pm/map_schema_validator/0.1.1/MapSchemaValidator.html#validate!/2)\n\n##","ref":"readme.html#usage","title":"Usage - MapSchemaValidator","type":"extras"},{"doc":"```elixir\nschema = %{\n  field: %{\n    inner_field: :string\n  }\n}\nmap = %{\n  field: %{\n    inner_field: \"value\"\n  }\n}\n\ncase MapSchemaValidator.validate(schema, map) do\n  {:ok, _} ->\n    :ok\n    # your stuff\n  {:error, %MapSchemaValidator.InvalidMapError{message: message}} ->\n    :error\n    # failure\nend\n\ntry do\n  :ok = MapSchemaValidator.validate!(schema, map)\nrescue\n  e in MapSchemaValidator.InvalidMapError -> \n    e.message\nend\n```\n\n##","ref":"readme.html#basic","title":"Basic - MapSchemaValidator","type":"extras"},{"doc":"You can check inner list of maps or even list of possible values, or even optional values using `?` at the end of the\nfield name in the schema\n\n```\n:float, :integer, :number, :boolean, :string, [:list], %{type: :map}, [%{type: :map}]\n```\n\n```elixir\nschema = %{\n  list: [\n    %{\n      inner_field: [:string, :number],\n      inner_list: [\n        %{\n          inner_leven_2_flag: [:boolean, :integer]\n        }\n      ],\n      inner_optional_flag?: :boolean\n    }\n  ]\n}\nmap = %{\n  list: [\n    %{\n      inner_field: \"value string\",\n      inner_list: [\n        %{\n          inner_leven_2_flag: true\n        }\n      ],\n      inner_optional_flag: false\n    },\n    %{\n      inner_field: 10,\n      inner_list: [\n        %{\n          inner_leven_2_flag: true\n        }\n      ]\n    }\n  ]\n}\n\n{:ok, _} = MapSchemaValidator.validate(schema, map)\n```","ref":"readme.html#possible-values","title":"Possible values - MapSchemaValidator","type":"extras"}]}